PublicBlumBlumShub Class Reference

BlumBlumShub without factorization of the modulus. More...

Inheritance diagram for PublicBlumBlumShub:

## Public Member Functions

| PublicBlumBlumShub (const Integer &n, const Integer &seed)
unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
byte | GenerateByte ()
| Generate new random byte and return it. More...
void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction. More...
Public Member Functions inherited from RandomNumberGenerator
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
virtual void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual bool | IsRandomAccess () const =0
| Determines whether the cipher supports random access. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...

## Detailed Description

BlumBlumShub without factorization of the modulus.

Definition at line 17 of file blumshub.h.

## Member Function Documentation

## GenerateBit()

unsigned int PublicBlumBlumShub::GenerateBit | ( |  | ) |

virtual

Generate new random bit and return it.

Returns
  a random bit

The default implementation calls GenerateByte() and return its lowest bit.

All generated values are uniformly distributed over the range specified within the the contraints of a particular generator.

Reimplemented from RandomNumberGenerator.

Definition at line 17 of file blumshub.cpp.

## GenerateByte()

byte PublicBlumBlumShub::GenerateByte | ( |  | ) |

virtual

Generate new random byte and return it.

Returns
  a random 8-bit byte

Default implementation calls GenerateBlock() with one byte.

All generated values are uniformly distributed over the range specified within the the contraints of a particular generator.

Reimplemented from RandomNumberGenerator.

Definition at line 28 of file blumshub.cpp.

## GenerateBlock()

void PublicBlumBlumShub::GenerateBlock | ( | byte * | output,
|  | size_t | size
| ) |  |

virtual

Generate random array of bytes.

Parameters

  output | the byte buffer
  size | the length of the buffer, in bytes

All generated values are uniformly distributed over the range specified within the the contraints of a particular generator.

Note
  A derived generator must override either GenerateBlock() or GenerateIntoBufferedTransformation(). They can override both, or have one call the other.

Reimplemented from RandomNumberGenerator.

Definition at line 36 of file blumshub.cpp.

## ProcessData()

void PublicBlumBlumShub::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

virtual

Encrypt or decrypt an array of bytes.

Parameters

  outString | the output byte buffer
  inString | the input byte buffer
  length | the size of the input and output byte buffers, in bytes

Either `inString == outString`, or they must not overlap.

Implements StreamTransformation.

Definition at line 42 of file blumshub.cpp.

## IsSelfInverting()

bool PublicBlumBlumShub::IsSelfInverting | ( |  | ) | const

inline virtual

Determines whether the cipher is self-inverting.

Returns
  true if the cipher is self-inverting, false otherwise

IsSelfInverting determines whether this transformation is self-inverting (e.g. xor with a keystream).

Implements StreamTransformation.

Definition at line 28 of file blumshub.h.

## IsForwardTransformation()

bool PublicBlumBlumShub::IsForwardTransformation | ( |  | ) | const

inline virtual

Determines if the cipher is being operated in its forward direction.

Returns
  true if DIR is ENCRYPTION, false otherwise

See also
  IsForwardTransformation(), IsPermutation(), GetCipherDirection()

Implements StreamTransformation.

Definition at line 29 of file blumshub.h.

The documentation for this class was generated from the following files:

- blumshub.h
- blumshub.cpp